.486
.model flat, stdcall
option casemap :none
  
include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\gdi32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\advapi32.inc
include \masm32\include\Comctl32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\shell32.inc
include \masm32\include\oleaut32.inc
include \masm32\include\ole32.inc
include \masm32\include\dialogs.inc
include \masm32\include\winmm.inc
include \masm32\include\msimg32.inc
   
   
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\advapi32.lib
includelib \masm32\lib\Comctl32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\oleaut32.lib
includelib \masm32\lib\ole32.lib
includelib \masm32\lib\winmm.lib
includelib \masm32\lib\msimg32.lib
   
include \masm32\macros\macros.asm

WndProc  PROTO :DWORD, :DWORD, :DWORD, :DWORD
Scroller PROTO
.const 
IDI_ICON    equ 200
IDD_DLG1    equ 101
TIMER1      equ 1
Stars       equ 200 ; number of stars
SCROLL_SIZE      = 300   ;Scroll size
SCROLL_HIGH      = 85 ; scroll hight up and down in the dialog window
SCROLL_LEFT      = 15 ;scroll left indent in the dialog window
SCROLL_RIGHT     = 15 ;scroll right indent in the dialog window 
Scroll_speed     = 25 ;scroll Speed... The greater the Number the Slower the Scrolling!
.data
szTitle      db 'Starfiled with resource example', 0   
black dd ?
  ScrollTxt       db "This is scroller example",0 
pt dd Stars dup (0,0,0) ;x,y,z+color
   
ptX dd 0
ptY dd 0
   
random dd 0
   
num256 REAL4 400.00 ; starting cluster size
   
.data?
hInstance       HINSTANCE ?
hIcon     HICON     ?
hmainDC         HDC       ?
hmainbmp        HBITMAP   ?
WindowRect      RECT     <?>
MyRect          RECT     <?>
rClientWindow   RECT     <?>
hbmp         HANDLE       ?
chdc         HDC          ?

PictureW       dd ?
PictureH       dd ?
hDialog       HWND ?
CommandLine 	LPSTR ?
hWindow			HWND ?
ScrollTxtBuf    db 256 dup (?)
hFont           dd ?
hThread         dd ?
ThreadID        dd ?
Handler         dd ?
Scroll_on       dd ?
.code
start:
   
   
mov hInstance,rv(GetModuleHandle,0)
  
INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax

; ---------------------------------------------
;   Call the dialog box stored in resource file
; ---------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR WndProc, 0
INVOKE ExitProcess, 0

WndProc PROC uses  ebx esi edi hWnd:HWND,uMsg:DWORD,wParam:DWORD,lParam:DWORD
LOCAL hdc:HDC
LOCAL ps:PAINTSTRUCT
LOCAL rect:RECT

mov eax,uMsg
mov edi,hWnd
mov Handler,edi
   .IF uMsg == WM_INITDIALOG
   
 INVOKE SetWindowText, hWnd, addr szTitle 
 INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon
 invoke CreateThread,0,0,addr Scroller,0,0,addr ThreadID     ; ( make thread with scroll )
mov    hThread,eax           
mov    hFont,eax
mov    Scroll_on,1                                          ; ( 1 is on) ( 0 is off )
       INVOKE  GetClientRect,hWnd,ADDR rect
         m2m PictureW,rect.right
         m2m PictureH,rect.bottom

      mov black,rv(CreateSolidBrush,black)
      
      invoke SetTimer, hWnd, TIMER1, 10, NULL
      
      invoke GetDC, hWnd
      mov hdc, eax
      
      mov esi,PictureW
      mov edi,PictureH

      invoke CreateCompatibleDC, hdc
      mov hmainDC,eax
      
      invoke CreateCompatibleBitmap, hdc, esi, edi
      mov hmainbmp,eax

      invoke SelectObject, [hmainDC], eax
      
      invoke ReleaseDC,hWnd, hdc
   
      invoke GetTickCount
      mov random,eax
      
      xor esi,esi

      CREATE_STARS:
      
      push eax
      
      imul ax,cx
      movsx eax,ax
      mov edx,eax
      shr edx,8
      mov ah,dh
      add al,3
      mov dword ptr [pt+esi],eax
      
      pop eax
      xor eax,[$+esi]
      movsx eax,ax
      mov edx,eax
      shr edx,8
      mov ah,dh
      mov dword ptr [pt+esi+4], eax

      imul ax,cx
      xor ax,si
      mov random,eax
      
      
      mov ecx,eax
      mov ch,1
      and ecx,0fffh
      mov dword ptr [pt+esi+8], ecx
      
      add esi,12
      cmp esi,Stars*12
      jne CREATE_STARS
      mov eax,1
      ret
   .ELSEIF uMsg == WM_PAINT
         mov hdc,rv(BeginPaint,hWnd,ADDR ps)
         invoke GetClientRect,hWnd,ADDR rect
      invoke BitBlt,hdc,0,0,rect.right,rect.bottom,hmainDC,0,0,SRCCOPY
      invoke EndPaint,hWnd,addr ps
      mov eax,1
      ret
  .ELSEIF  uMsg == WM_KEYDOWN
.ELSEIF wParam == VK_ESCAPE
  INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0

   .ELSEIF uMsg == WM_TIMER
      xor esi,esi
      invoke GetClientRect,hWnd,ADDR rect
      invoke FillRect,hmainDC,ADDR rect,rv(GetStockObject,BLACK_BRUSH)
      .while esi < Stars*12
         call starfield
         invoke SetPixel, hmainDC, ptX, ptY, eax
         add esi,12 ; next stars
         .endw
      invoke InvalidateRect,hWnd,0,0
         mov eax,1
         ret
   .ELSEIF uMsg == WM_CLOSE
      destroy:
      invoke PostQuitMessage,NULL
      invoke DeleteDC, [hmainDC]
      invoke DeleteObject, [hmainbmp]
      invoke DeleteObject, black
      invoke KillTimer, hWnd, TIMER1
      INVOKE EndDialog,hWnd, 0
   .ENDIF
   
   xor eax,eax
   ret
   
   
   starfield:
   
   finit
   
   dec dword ptr [pt+esi+8]
   
   fild word ptr [pt+esi+8] ;z
   fld num256
   
   fild dword ptr [pt+esi] ;x
   fmul st(0),st(1)
   fdiv st(0),st(2)
   fistp dword ptr [ptX]
  mov     eax,PictureW
      shr     eax,1
      add     ptX,eax ; center
   
   
   fild dword ptr [pt+esi+4] ;y
   fmul st(0),st(1)
   fdiv st(0),st(2)
   fistp dword ptr [ptY]
   mov     eax,PictureH
      shr     eax,1
      add     ptY,eax

   
   
   
   mov ecx,PictureW
   mov edx,PictureH
   .if ptX > ecx || ptY > edx
   call CHANGE_STARS
   .ENDIF
   
   
   xor eax,eax
   mov al,byte ptr [pt+esi+8+3] ; color
   mov ah,al
   shl eax,8
   mov al,ah
   
   
   .IF byte ptr [pt+esi+8+3] != 0FFh ; color white max
   inc byte ptr [pt+esi+8+3]
   .ENDIF
   
   
   retn
   
   
   CHANGE_STARS: ;change stars coord.
   
   mov eax, random
   
   push eax
   
   imul ax,cx
   movsx eax,ax
   mov edx,eax
   shr edx,8
   mov ah,dh
   add al,3
   mov dword ptr [pt+esi],eax
   
   pop eax
   xor eax,[$+esi]
   movsx eax,ax
   mov edx,eax
   shr edx,8
   mov ah,dh
   mov dword ptr [pt+esi+4], eax
   
   
   imul ax,cx
   xor ax,si
   mov random,eax
   
   
   mov ecx,eax
   mov ch,1
   and ecx,0fffh
   mov dword ptr [pt+esi+8], ecx ; fface z et raz la couleur
   
   
   retn
   ;-------------------------------------------------------------------------
   
WndProc ENDP
Scroller PROC uses esi edi ebx edx
LOCAL  TextDC:DWORD
LOCAL rect:RECT

 @@:
       invoke Sleep,100
       cmp    Scroll_on,1
       jne    @B

       invoke GetDC,Handler
       mov    ebx,eax
       invoke CreateCompatibleBitmap,eax,310,16
       push   eax
       invoke CreateCompatibleDC,ebx
       mov    edi,eax
       pop    ecx
       invoke SelectObject,eax,ecx
       invoke BitBlt,edi,0,0,310,16,ebx,0,0,SRCCOPY

       invoke CreateCompatibleDC,edi
       mov    TextDC,eax
       invoke CreateCompatibleBitmap,edi,310,16
       invoke SelectObject,TextDC,eax

       invoke SetTextColor,TextDC,00FFFFFFh ; text color "0h" is Black
       invoke SetBkMode,TextDC,TRANSPARENT
       invoke SelectObject,TextDC,hFont

       invoke BitBlt,TextDC,0,0,310,16,ebx,0,0,SRCCOPY
     ; invoke BitBlt,TextDC,0,0,rect.right,rect.bottom,ebx,0,0,SRCCOPY
Scroll_:
       mov    esi,301

Scroll:
       invoke BitBlt,TextDC,0,0,310,16,edi,0,0,SRCCOPY
       cmp    ScrollTxt,'1'

       invoke TextOut,TextDC,esi,2,addr  ScrollTxt,sizeof ScrollTxt-1
       invoke BitBlt,ebx,SCROLL_LEFT,SCROLL_HIGH,SCROLL_SIZE-SCROLL_LEFT-SCROLL_RIGHT,16,TextDC,0,0,SRCCOPY

       invoke Sleep,Scroll_speed
       dec    esi
       cmp    esi,-195
       jnz    Scroll
       jmp    Scroll_
       ret
Scroller  endp 
END start